# -*- coding: iso-8859-15 -*-
# $Id: Install.py 22113 2005-12-16 15:36:02Z kilobug $
## Install.py - Plone QuickInstaller method for product

#from Products.CMFCore.utils import getToolByName, SimpleItemWithProperties

from Products.Archetypes.Extensions.utils import install_subskin
from Products.Mailnode import PROJECTNAME, product_globals
from Products.Mailnode.Mailnode import Mailnode
from Products.CMFCore.utils import getToolByName

from StringIO import StringIO

def install_skins(self, out, skinsdir, product_globals):
    """ Install product skins and register them to portal_skins."""

    print >> out, '* Installing and registering layers from directory %s\n' % skinsdir

    install_subskin(self, out, globals=product_globals)

def install_tool(self, out, product_globals):
    """ Setup a tool in the Plone site."""

    # Add the tool if it does not already exist.
    bt = getToolByName(self, Mailnode.id, None)
    if bt is None:
        print >> out, "* Installing %s as %s\n" % (Mailnode.meta_type, Mailnode.id)
        portal = getToolByName(self, 'portal_url').getPortalObject()
        addTool = portal.manage_addProduct[PROJECTNAME].manage_addTool
        addTool(type = Mailnode.meta_type)

        bt = getToolByName(self, Mailnode.id)

        # Restrict access to the tool to the Manager only.
        bt.manage_permission('View', ['Manager'])


def install_external(self, out, method, module, function, product_globals):
    """Setup an External Method"""
    portal = getToolByName(self, 'portal_url').getPortalObject()
    obj = getattr(portal.aq_inner, method, None)
    if obj is None:
        print >> out, "* Installing %s.%s as %s\n" % (module, function, method)
        portal.manage_addProduct['ExternalMethod'].manage_addExternalMethod(method, "", PROJECTNAME + "." + module, function)


def install_access_rule(self, out, name, product_globals):
    """Setup an External Method"""
    portal = getToolByName(self, 'portal_url').getPortalObject()    
    print >> out, "* Setting %s as access rule\n" % (name)
    portal.manage_addProduct['SiteAccess'].manage_addAccessRule(name)
        
def remove_object(self, out, name):
    """Remove an object"""
    portal = getToolByName(self, 'portal_url').getPortalObject()
    obj = getattr(portal.aq_inner, name, None)
    if not obj is None:
        print >> out, "* Removing %s\n" % (name)
        portal.manage_delObjects([ name ])

def install(self):
    out = StringIO()
    install_skins(self, out, 'skins', product_globals)
    install_tool(self, out, product_globals)

    print >> out, ' done.\n'

    return out.getvalue()

def uninstall(self):
    out = StringIO()

    print >> out, ' done.\n'

    return out.getvalue()
